#include "StaticPlaceMobility.h"

Define_Module(StaticPlaceMobility);

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ===================================
/**
 * Initialization routine
 */
void StaticPlaceMobility::initialize(int aStage)
{
    BasicMobility::initialize(aStage);

    EV << "initializing StaticPlaceMobility stage " << aStage << endl;
	
	if (1 == aStage)
	{
		mNumHosts = par("numHosts");
		
        int size    = (int)ceil (sqrt(mNumHosts));
		double row  = ceil((hostPtr->index()) / size);
		int col     = (hostPtr->index()) % size;
		pos.x       = col * playgroundSizeX() / (size-1);
		if(pos.x == playgroundSizeX()) pos.x-=1;
		pos.y       = row * playgroundSizeY() / (size-1);
		if(pos.y == playgroundSizeY()) pos.y-=1;
        
		updatePosition();
	}

}

void StaticPlaceMobility::finish()
{
	BasicMobility::finish();
	recordScalar("x", pos.x);
	recordScalar("y", pos.y);
}
